<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="职位标题" prop="title">
        <el-input
          v-model="queryParams.title"
          placeholder="请输入职位标题"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="职位要求" prop="requirement">
        <el-input
          v-model="queryParams.requirement"
          placeholder="请输入职位要求"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="岗位" prop="jobCategoryId">
        <el-select v-model="queryParams.jobCategoryId" placeholder="请选择">
          <el-option
            v-for="item in postList"
            :key="item.id"
            :label="item.name"
            :value="item.id!"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="发布时间" prop="publishTime">
        <el-date-picker
          v-model="queryParams.publishTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-220px"
        />
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-220px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['portal:job-post:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['portal:job-post:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="主键ID" align="center" prop="id" />
      <el-table-column label="岗位" align="center" prop="jobCategoryId" >
        <template #default="scope">
          <template v-for="item in postList">
            <el-tag type="success" :key="item.id" v-if="item.id == scope.row.jobCategoryId">
              {{ item.name }}
            </el-tag>
          </template>
        </template>
      </el-table-column>
      <el-table-column label="职位标题" align="center" prop="title" />
      <el-table-column label="职位描述" align="center" prop="description" />
      <el-table-column label="职位要求" align="center" prop="requirement" />
      <el-table-column label="城市" align="center" prop="cityId" >
        <template #default="scope">
          <el-tag type="success">
            {{ findFullPathById(scope.row.cityId,areaList) }}
          </el-tag>
        </template>
      </el-table-column>

      <el-table-column
        label="发布时间"
        align="center"
        prop="publishTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" align="center" min-width="120px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['portal:job-post:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['portal:job-post:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <JobPostForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { JobPostApi, JobPostVO } from '@/api/portal/jobpost'
import JobPostForm from './JobPostForm.vue'
import * as PostApi from "@/api/system/post";
import * as AreaApi from "@/api/system/area";
import {defaultProps} from "@/utils/tree";

/** 职位 列表 */
defineOptions({ name: 'JobPost' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化
const postList = ref([] as PostApi.PostVO[]) // 岗位列表
const areaList = ref([]) // 地区列表

const loading = ref(true) // 列表的加载中
const list = ref<JobPostVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  title: undefined,
  description: undefined,
  requirement: undefined,
  cityId: undefined,
  jobCategoryId: undefined,
  publishTime: [],
  createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await JobPostApi.getJobPostPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 查询列表 */
const initSelectData = async () => {
  // 加载岗位列表
  postList.value = await PostApi.getSimplePostList()
  // 获得地区列表
  areaList.value = await AreaApi.getAreaTree();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await JobPostApi.deleteJobPost(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await JobPostApi.exportJobPost(queryParams)
    download.excel(data, '职位.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/**
 * table中显示位置、城市标签
 * @param targetId
 * @param list
 * @param path
 */
const findFullPathById = (targetId: number, list: any[], path: string[] = []): string | null => {
  for (const node of list) {
    if (node.id === targetId) {
      return [...path, node.name].join("/");
    }
    if (node.children?.length) {
      const result = findFullPathById(targetId, node.children, [...path, node.name]);
      if (result) return result;
    }
  }
  return null;
};


/** 初始化 **/
onMounted(() => {
  getList()
  initSelectData();
})
</script>
